// Remove this file on final merge. 

#include <cis-workflow-gen/quick-include.hpp>

int main() {
    #define A_2(task, entityName) ManualOperation("Task notice: "#task, "Hey, man. You need to build " #task, teamid, #entityName)
    #define A_1(arg1) A_2(arg1, )
    #define A_proxy(x, Arg1, Arg2, FUNC, ...) FUNC
    #define A(...) A_proxy(, ##__VA_ARGS__, A_2(__VA_ARGS__), A_1(__VA_ARGS__))
    #define AV(task, entityName) Noop("Virtual task: "#task, #entityName)

    auto teamid = "TODO.EOPTeamId";
    auto seqBody = 
    /*148*/ A(EOPServerDock) >> 
    /*149*/ A(EOPServerRTEG) >> 
    /*151*/ A(ConfigCheckin_And_ImportInventory) >> 
    /*152*/ A(EOPNetworkPrep) >> 
    /*153*/ A(RackElevation_And_ServerImport) >> 
    /*154*/ A(BurninPayload) >> 
    /*156*/ A(NewForestCreation) >> 
    /*157*/ A(GLSSetup_And_CNAMECreation) >> 
    /*158*/ A(StatefulFlattening) >> 
    /*159*/ A(DBDeployment) >> 
    /*160*/ A(StatelessDeployment, EntityTodo) >> 
    /*162*/ A(ForwardSync) >> 
    /*163*/ A(GTMGLSDNSConfigurations) >> 
    /*164*/ A(TestTenantCreation) >> 
    /*165*/ A(ValidationandComponentSignoff, EntityTodo) >> 
    /*166*/ A(WorkloadIntegrationwithEXO) >> 
    /*167*/ AV(EOPEngineeringReadinessSweden, EntityTodo);

    auto flowEop = 
    /*147*/ A(TAMAward) | 
        seqBody;
    
    println(to_file("GoLocalSE_EOPWorkflow.xaml"), flowEop.generateXaml("FleetAGC.Workflows.GoLocalSE_EOP"));

    teamid = "TODO.SPOTeamId";
    auto flowSpo = 
    /*114*/ A(TAMAward) | (
        /*115*/ A(SPOServer_And_NetworkDock) >> 
        /*116*/ A(SPOServer_And_NetworkRTEG) >> 
        /*119*/ A(ServerValidationNetwork_And_Hardware) >> 
        /*120*/ A(ServerImaging) >> 
        /*121*/ A(AzureSubscription_And_SubmitandValidateConsumption) >> 
        /*123*/ A(SPOFarmDeployments, EntityTodo_46) >> (
            /*124*/ A(SPOPostDeploymentValidation) | (
            /*126*/ A(MicroservicesDeployment, EntityTodo_487278) >> 
            /*127*/ A(MicroservicesPostDeploymentValidation)
            ) >> 
            /*128*/ AV(ServiceReadiness, EntityTodo_108) >> 
            /*129*/ AV(WorkloadIntegration, EntityTodo_176_185)
        )
    );

    println(to_file("GoLocalSE_SPOWorkflow.xaml"), flowSpo.generateXaml("FleetAGC.Workflows.GoLocalSE_SPO"));

    teamid = "TODO.EXOTeamId";
    auto flowExo = 
    /*86*/    A(Backends_TAMAward) | 
    /*96*/    A(CAFE_Substrate_TAMAward) |
    ( // begin the huge body
    ( // dep group of 100
    /*8384*/ (A(ActiveDirectoryDock) >> A(ActiveDirectoryRteg)) | 
    /*8788*/ (A(BackEndsDock) >> A(BackEndsRteg)) |
    /*9091*/ (A(ManagementDock) >> A(ManagementRteg)) |
    /*9394*/ (A(CafeDock) >> A(CafeRteg)) |
    /*9798*/ (A(SubstrateDock) >> A(SubstrateRteg))
    ) >> 
    /*100*/ A(DiscoveryADBackEndCafeSubstrateAllocationofServersIPsandRoles) >> 
    /*101*/ AV(ApplicationDeployment, EntityTodo_697744) >> 
    /*102*/ A(ResourceForestDeployment) >> 
    /*103*/ A(Backend_And_FrontEndDeployment) >> 
    /*104*/ A(CapacityUnitPrepDAG_And_CAFE) >> 
    /*106*/ A(ComponentValidation, EntityTodo_157) >> 
    /*107*/ A(Bugfix_And_Hotfixes) >> 
    /*108*/ A(MonitoringSetup) >> 
    /*109*/ A(WorkloadIntegration, EntityTodo_176_185) >> 
    /*110*/ AV(EXOEngineeringReadinessSweden, EntityTodo_nothing)
    ); // end the huge body. 

    println(to_file("GoLocalSE_EXOWorkflow.xaml"), flowExo.generateXaml("FleetAGC.Workflows.GoLocalSE_EXO"));

    teamid = "TODO.FastSearchTeamId";
    auto flowFS = 
    /*134*/ A(RTEGAzureResources, EntityTodo_48) | 
    /*135136*/ (A(Dock, EntityTodo_115) >> A(RTEG)) >> 
    /*138*/ AV(InfrastuctureDeployment, ) >>
    (
    /*139*/ A(ServerValidationNetwork_And_Hardware) >> 
    /*140*/ A(ServerImaging) >> 
    /*141*/ A(AzureSubscription_And_SubmitandValidateConsumption)
    ) | 
    /*142*/ A(FASTDeployment);
    // Node143 depends on nothing in this workflow. I don't know where to put it. Wait for the email reply, I believe it depends on 141+142. 
    /*143*/ AV(FASTEngineeringReadinessSweden, EntityTodo_143);

    println(to_file("GoLocalSE_FastSearchWorkflow.xaml"), flowFS.generateXaml("FleetAGC.Workflows.GoLocalSE_FastSearch"));

    teamid = "TODO.WacTeamId";
    auto flowWac = 
    /*171*/ A(RTEGAzureResources, EntityTodo_47_73) >> 
    /*173*/ A(InfrastructureDeployment) >> 
    /*174*/ A(ServiceDeployment) >> 
    /*175*/ AV(ServiceReadiness, ) >> 
    /*176*/ AV(WACEngineeringReadinessSweden, );

    println(to_file("GoLocalSE_WACWorkflow.xaml"), flowWac.generateXaml("FleetAGC.Workflows.GoLocalSE_WAC"));

    teamid = "TODO.OCSTeamId";
    auto flowOcs = 
    /*180*/ A(RtegAzureResources) >> 
    /*182*/ A(infrastuctureDeployment) >> 
    /*183*/ A(ServiceDeployment) >> 
    /*184*/ AV(ServiceReadiness, ) >> 
    /*185*/ AV(OCSEngineeringReadinessSweden, );

    println(to_file("GoLocalSE_OCSWorkflow.xaml"), flowOcs.generateXaml("FleetAGC.Workflows.GoLocalSE_OCS"));

    teamid = "TODO.TeamsTeamId";
    auto flowTeams = 
    ( // first half begin
    /*188*/ AV(TeamsRTEG, ) >> 
    /*189*/ A(PreRegCompute) | 
    /*190*/ A(RTEGAzureResources)
    ) | ( // second half begin
    /*192*/ A(ServicesDeployment) >> 
    /*193*/ A(TestingandStamping) >> 
    /*194*/ A(TeamsEngineeringReadinessSweden, EntityTodo_167_110)
    );

    println(to_file("GoLocalSE_TeamsWorkflow.xaml"), flowTeams.generateXaml("FleetAGC.Workflows.GoLocalSE_Teams"));

    teamid = "TODO.CountryLaunchTeamId";
    auto flowCL = 
    // I believe that, all of them should be Virtual Activity... (Use Noop)
    /*196*/ AV(SwedenGAWorkloadAvailability, EntityTodo_manymanydep) >> 
    /*197*/ A(SwedenGABakePeriod) >> 
    /*198*/ A(SwedenGAMarketingRelease);

    println(to_file("GoLocalSE_CountryLaunchWorkflow.xaml"), flowCL.generateXaml("FleetAGC.Workflows.GoLocalSE_CountryLaunch"));

  

}

